unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, FileCtrl;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label2: TLabel;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    Edit2: TEdit;
    Label1: TLabel;
    Button2: TButton;
    BitBtn1: TBitBtn;
    GroupBox2: TGroupBox;
    BitBtn2: TBitBtn;
    Memo1: TMemo;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    SaveDialog1: TSaveDialog;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Label3: TLabel;
    Edit1: TEdit;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    Label5: TLabel;
    Edit3: TEdit;
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    procedure ScanDir(dir, showdir : String);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

Var
   ListFile, ProgramDir : String;
   StartDir, CurrentDir : String;
   Filter : String;
   MaxDept, CurrentDept : Integer;
   LF, LD : TextFile;
   Stopped : Boolean;

{$R *.dfm}

procedure TForm1.Button2Click(Sender: TObject);
Var
   s : String;
   k : Integer;
begin
SaveDialog1.InitialDir := DirectoryListBox1.Directory;
If SaveDialog1.Execute Then
   Begin
   ListFile := SaveDialog1.FileName;
   k := Length(ListFile);
   s := '';
   While (ListFile[k] <> '\') Or (k = 0) Do
         begin
         s := ListFile[k]+s;
         Dec(k);
         end;
   If Pos('.', s) = 0 Then
      Begin
      s := s + '.txt';
      ListFile := ListFile + '.txt';
      End;
   Edit2.Text := s;
   End;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
ProgramDir := ParamStr(0);
While ProgramDir[Length(ProgramDir)] <> '\' Do
      ProgramDir := Copy(ProgramDir, 1, Length(ProgramDir)-1);
ListFile := '';
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var 
   SaveCursor : TCursor;
   temps : String;
begin
Stopped := False;
If (ListFile = '') Or (Pos('\', ListFile) = 0) Then
   Begin
   MessageDlg('Select a List File first', mtWarning, [mbOk], 0);
   Button2Click(Sender);
   If (ListFile = '') Or (Pos('\', ListFile) = 0) Then Exit
   End;
StartDir := DirectoryListBox1.Directory;
CurrentDir := StartDir;
CurrentDept := 0;
MaxDept := StrToInt(Edit1.Text);
If MaxDept = 0 Then MaxDept := 255;
Filter := Edit3.Text;
If Filter = '' Then Filter := '*.*';
If Filter = '*' Then Filter := '*.*';
If (Pos('.', Filter) = 0) Then Filter := '.'+Filter;
If (Pos('*', Filter) = 0) Then Filter := '*'+Filter;
Edit3.Text := Filter;
Memo1.Clear;
AssignFile(LF, ListFile);
Rewrite(LF);
If CheckBox5.Checked Then
   Begin
   temps := ListFile;
   While temps[Length(temps)] <> '.' Do
         temps := Copy(temps, 1, Length(temps)-1);
   temps := Copy(temps, 1, Length(temps)-1);
   AssignFile(LD, temps+' DIR.txt');
   Rewrite(LD);
   End;
BitBtn1.Enabled := False;
BitBtn2.Enabled := True;

SaveCursor := Screen.Cursor;
Screen.Cursor := crHourGlass;

If CurrentDir[Length(Currentdir)] <> '\' Then
   CurrentDir := CurrentDir + '\';
ScanDir(Currentdir, 'root\');

CloseFile(LF);
If CheckBox5.Checked Then CloseFile(LD);
Memo1.Lines.Add('- END OF SCANNING -');
BitBtn1.Enabled := True;
BitBtn2.Enabled := False;
Screen.Cursor := SaveCursor;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
If CheckBox1.Checked Then
   Begin
   Label3.Enabled := True;
   Edit1.Enabled := True;
   End
   Else
   Begin
   Label3.Enabled := False;
   Edit1.Enabled := False;
   End
end;

function SizeToString(size : Integer) : string;
Var
   s, s1 : String;
   k : Integer;
Begin
size := size Div 1024;
If size = 0 Then size := 1;
s := IntToStr(size);
s1 := '';
For k := 1 To Length(s) Do
    begin
    s1 := s[Length(s)-k+1] + s1;
    If k Mod 3 = 0 Then s1 := '.' + s1;
    end;
If s1[1] = '.' Then s1 := Copy(s1, 2, Length(s1)-1);
s1 := s1 + ' Kb';
SizeToString := s1;
End;

procedure TForm1.ScanDir(dir, showdir : String);
var
  sr : TSearchRec;
  Dirs : TStringList;
  Files : TStringList;
  k, tempi, tempi1, tempi2 : Integer;
  temps, temps1, SSize, STime : String;
  MaxNameLength, MaxTimeLength, MaxSizeLength : Integer;
begin
If Stopped Then Exit;
If dir[Length(dir)] <> '\' Then dir := dir + '\';
Inc(CurrentDept);
If CheckBox1.Checked Then
   Dirs := TStringList.Create;
Files := TStringList.Create;
MaxNameLength := 0;
MaxSizeLength := 0;
MaxTimeLength := 0;

Memo1.Lines.Add('----------------------------------------------------------------------------------------------------------------------');
Memo1.Lines.Add('SCANNING DIR: '+dir);
Memo1.Lines.Add('----------------------------------------------------------------------------------------------------------------------');

If FindFirst(dir+filter, FaAnyFile, sr) = 0 then
    begin
      Application.ProcessMessages;
      If Stopped Then Exit;
      repeat
      If (sr.Name <> '.') And (sr.Name <> '..') And (sr.Name <> '')  And
         (sr.Attr AND faHidden <> sr.Attr) And
         (sr.Attr AND faSysFile <> sr.Attr) And
         (sr.Attr AND faVolumeID <> sr.Attr) And
         (sr.Attr AND faDirectory = sr.Attr) And
         CheckBox1.Checked And (CurrentDept <= MaxDept) Then
         Dirs.Add(sr.Name);
      If (sr.Name <> '.') And (sr.Name <> '..') And (sr.Name <> '')  And
         (sr.Attr AND faHidden <> sr.Attr) And
         (sr.Attr AND faSysFile <> sr.Attr) And
         (sr.Attr AND faVolumeID <> sr.Attr) And
         (sr.Attr AND faDirectory <> sr.Attr) Then
         Begin
         temps := sr.Name;
         If MaxNameLength < Length(temps) Then MaxNameLength := Length(temps);
         SSize := SizeToString(sr.Size);
         If MaxSizeLength < Length(SSize) Then MaxSizeLength := Length(SSize);
         STime := DateTimeToStr(FileDateToDateTime(sr.Time));
         If MaxTimeLength < Length(STime) Then MaxTimeLength := Length(STime);
         If CheckBox2.Checked Then
            temps := temps+'?'+SSize;
         If CheckBox3.Checked Then
            temps := temps+'?'+STime;
         Files.Add(temps+'?');
         Memo1.Lines.Add(sr.Name);
         End;
      until FindNext(sr) <> 0;
      FindClose(sr);
    end;

Application.ProcessMessages;

If Files.Count > 0 Then
   Begin
   WriteLn(LF, '');
   WriteLn(LF, '----------------------');
   If CheckBox4.Checked Then
      Begin
      If CheckBox5.Checked Then
         WriteLn(LD, '');
      temps := showdir;
      temps1 := '';
      tempi1 := 0;
      For tempi := 1 To Length(temps) Do
          Begin
          If temps[tempi] <> '\' Then
             temps1 := temps1 + temps[tempi]
             Else
             Begin
             If tempi1 > 0 Then
                Begin
                For tempi2 := 1 To tempi1 Do
                    Begin
                    Write(LF, ' ');
                    If CheckBox5.Checked Then
                       Write(LD, ' ');
                    End;
                Write(LF, '\ ');
                If CheckBox5.Checked Then
                   Write(LD, '\ ');
                End;
             WriteLn(LF, temps1);
             If CheckBox5.Checked Then
                WriteLn(LD, temps1);
             temps1 := '';
             Inc(tempi1)
             End;
          End;
      End
      Else
      Begin
      If CheckBox5.Checked Then
         WriteLn(LD, Copy(showdir, 1, Length(showdir)-1));
      WriteLn(LF, Copy(showdir, 1, Length(showdir)-1));
      End;
   WriteLn(LF, '----------------------');
   End;

Files.Sort;
For k := 1 To Files.Count Do
    Begin
    temps := Files.Strings[k-1];
    temps1 := Copy(temps, 1, Pos('?', temps)-1);
    temps := Copy(temps, Pos('?', temps)+1, Length(temps)-Pos('?', temps));
    Write(LF, temps1);
    If temps <> '' Then
       begin
       tempi := MaxNameLength - Length(temps1) + 5;
       temps1 := Copy(temps, 1, Pos('?', temps)-1);
       temps := Copy(temps, Pos('?', temps)+1, Length(temps)-Pos('?', temps));
       For tempi1 := 1 To tempi Do temps1 := ' ' + temps1;
       Write(LF, temps1);
       end;
    If temps <> '' Then
       begin
       tempi := MaxSizeLength - (Length(temps1)-tempi) + 5;
       temps1 := Copy(temps, 1, Pos('?', temps)-1);
       temps := Copy(temps, Pos('?', temps)+1, Length(temps)-Pos('?', temps));
       For tempi1 := 1 To tempi Do temps1 := ' ' + temps1;
       Write(LF, temps1);
       end;
    WriteLn(LF);
    End;
Files.Free;

If CheckBox1.Checked Then
   Begin
   Dirs.Sort;
   temps := showdir;
   If CurrentDept = 1 Then temps := '';
   For k := 1 To Dirs.Count Do
       Begin
       If Stopped Then Exit;
       ScanDir(dir+Dirs.Strings[k-1], temps+UpperCase(Dirs.Strings[k-1])+'\');
       End;
   End;

Dec(CurrentDept);
If CheckBox1.Checked Then
   Dirs.Free
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
Stopped := True;
end;

end.
